select custid,prodname,
     case when rank = 1 then '1 - Platinum'
          when rank = 2 then '2 - Gold'
          when rank = 3 then '3 - Silver'
          else 'N/A'
          end as rank
  from (select state,city,customer.custid,prodname
              ,rank() over (partition by prodname
                 order by nvl(avg(amount),0) desc)
                        as rank
            from customer,sales
            where customer.custid = sales.custid
            group by state,city,customer.custid,prodname)
   where prodname like 'ACE TENNIS RACKET%'
     and rank < 4
   order by prodname,rank
/